HDU--杭电--1242--Rescue--广搜--又是一个所谓的优先队列起作用的题,擦,虽然比上一个容易,不过还是拿来摆摆

擦,是不是又是所谓的优先队列?没空,所以还是用我家小暴力来解决

Rescue

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 12175    Accepted Submission(s): 4439


Problem Description
Angel was caught by the MOLIGPY! He was put in prison by Moligpy. The prison is described as a N * M (N, M <= 200) matrix. There are WALLs, ROADs, and GUARDs in the prison.

Angel's friends want to save Angel. Their task is: approach Angel. We assume that "approach Angel" is to get to the position where Angel stays. When there's a guard in the grid, we must kill him (or her?) to move into the grid. We assume that we moving up, down, right, left takes us 1 unit time, and killing a guard takes 1 unit time, too. And we are strong enough to kill all the guards.

You have to calculate the minimal time to approach Angel. (We can move only UP, DOWN, LEFT and RIGHT, to the neighbor grid within bound, of course.)
 


 

Input
First line contains two integers stand for N and M.

Then N lines follows, every line has M characters. "." stands for road, "a" stands for Angel, and "r" stands for each of Angel's friend.

Process to the end of the file.
 


 

Output
For each test case, your program should output a single integer, standing for the minimal time needed. If such a number does no exist, you should output a line containing "Poor ANGEL has to stay in the prison all his life."
 


 

Sample Input
  
  
7 8 #.#####. #.a#..r. #..#x... ..#..#.# #...##.. .#...... ........
 


 

Sample Output
  
  
13

 

#include <iostream>
#include <queue>
using namespace
std;
char
map[222][222];
int
visit[222][222],n,m,s,x1,x2,y1,y2,xx[4][2]={{-1,0},{1,0},{0,-1},{0,1}};  //visit记录是否访问,(x1,y1)(x2,y2)是起、终点
struct
ssss
{

    int
x,y,t;
}
ss;
queue<ssss> q,qq;
void
bfs()
{

    int
i,x,y,X,Y,t;
    while
(!
q.empty())  队列非空
    {

        ss=q.front();q.pop();
        X=ss.x;Y=ss.y;ss.t++;  //ss中时间加一,X记录ss中x,Y记录ss中y
        if
(
map[X][Y]=='x'){map[X][Y]='X';q.push(ss);continue;}  //碰上x就把继续入队,但是要知道上一步已经把ss中的t加一了,顺便把x变成X
        for
(
i=0;i<4;i++)
        {

            x=X+xx[i][0];
            y=Y+xx[i][1];
            if
(
x>=0&&y>=0&&x<n&&y<m&&visit[x][y]&&map[x][y]!='#')  //判断是否过界,是否访问,是否是#
            {

                if
(
x==x2&&y==y2){s=ss.t;return;}  //找到目标了,直接记录并结束就OK
                visit[x][y]=0;ss.x=x;ss.y=y;q.push(ss);  //标记访问,把当前的(x,y)打包并入队,这又用单上面那个ss里面的t已经加一,所以不用管t了
            }
        }
    }
}

int
main (void)
{

    int
i,j,k,l;
    while
(
cin>>n>>m)
    {

        for
(
i=0;i<n;i++)
            for
(
j=0;j<m;j++)
            {

                cin>>map[i][j];visit[i][j]=1;
                if
(
map[i][j]=='r')x1=i,y1=j;  //记录起点
                if
(
map[i][j]=='a')x2=i,y2=j;  //记录终点
            }

            q=qq;ss.x=x1;ss.y=y1;ss.t=0;s=0;q.push(ss);visit[x1][y1]=0;  //初始化队列,把起点打包并入队且标记起点为已经访问
            bfs();
            if
(
s)cout<<s<<endl;
            else
cout<<"Poor ANGEL has to stay in the prison all his life."<<endl;
    }

    return
0;
}

看吧~写到底还不是一样是暴力,有的人看过我的1026了,但是看看这个是不是更加懂我为什么这样做咯?这样就是模拟,也就是想象有个当前时间和一个总时间,总时间是懂的,我把这个当前时间处理处理那么不久形成了先后顺序了?优先队列不就是利用的这个么?

       这个题就是1026的简化版,这个就好像怪物的血量只会是1,亲,你说呢?嘿嘿

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值